# Data Fusion: Theory, Methods, and Applications

An open-access research monograph by [Marek Gagolewski](https://www.gagolewski.com)
([download PDF](https://raw.githubusercontent.com/gagolews/datafusion/master/datafusion.pdf))


---

A **proper fusion of complex data** is of interest to many researchers in
diverse fields, including computational statistics, computational geometry,
bioinformatics, machine learning, pattern recognition, quality management,
engineering, statistics, finance, economics, etc. It plays a crucial role in:

* synthetic description of data processes or whole domains,
* creation of rule bases for approximate reasoning tasks,
* reaching consensus and selection of the optimal strategy
    in decision support systems,
* imputation of missing values,
* data deduplication and consolidation,
* record linkage across heterogeneous databases,
* clustering.

Furthermore, many useful machine learning methods are based on a proper
aggregation of information entities. In particular, the class of ensemble
methods for classification is very successful because of the assumption
that no single "weak" classifier can perform as nicely as the whole group.
Neural networks and other deep learning tools can be understood as hierarchies
of individual fusion functions. Appropriate data fusion is crucial
for privacy reasons as well (think: GDPR).

This **open-access research monograph** integrates the spread-out results from
different domains using the methodology of the well-established classical
aggregation framework, introduces researchers and practitioners
to Aggregation 2.0, as well as points out the challenges and interesting
directions for further research.

---

[Gagolewski M.](https://www.gagolewski.com),
[*Data Fusion: Theory, Methods, and Applications*](https://raw.githubusercontent.com/gagolews/datafusion/master/datafusion.pdf),
Institute of Computer Science, Polish Academy of Sciences, Warsaw, Poland,
2015, 290 pp., ISBN:978-83-63159-20-7.

Reviewers:
[Gleb Beliakov](https://scholar.google.com/citations?user=_plRpWEAAAAJ) and
[Radko Mesiar](https://scholar.google.com/citations?user=_kXpl5YAAAAJ).
